<?php
/**
 * Amazon module return as json_encode
 * http://www.aa-team.com
 * =======================
 *
 * @author		Andrei Dinca, AA-Team
 * @version		1.0
 */
echo json_encode(array(
	// create the box elements array
	'option_name' => 'sp_Import_Settings',

	'tabs' => array(
		'template' => array(
			'label' 	=> 'Layout', 
			'elements' 	=> 'template_default, where_to_show, next_label, previous_label, link_text_color, current_item_text_color, hover_link_text_color, template_font_family, template_font_size, template_show_border, template_border_color'
		),
		'frontend' => array(
			'label' 	=> 'Advanced Settings', 
			'elements' 	=> 'sp_gap_number, sp_range, sp_anchor'
		),
		'theme_fixes' => array(
			'label'		=> 'Theme Fixes',
			'elements' 	=> 	'custom_css_selector, custom_css_woocommerce_selector'
		)
	),

	'elements' => array(

		/* to do functionalitate alex */

		'template_default' => array(
            'type' => 'image_radio',
            'std' => '0',
            'size' => 'small',
            //'force_width' => '150',
            'title' => 'General Style',
            'desc' => 'The default template to be used in the frontend',
            'options' => array(
            	array(
            		'caption' => 'Template 1',
            		'img' => sp()->assetUrl('images/model0.jpg')
            	),
            	array(
            		'caption' => 'Template 2',
            		'img' => sp()->assetUrl('images/model1.jpg')
            	),
            	array(
            		'caption' => 'Template 3',
            		'img' => sp()->assetUrl('images/model2.jpg')
            	),
            	array(
            		'caption' => 'Template 4',
            		'img' => sp()->assetUrl('images/model3.jpg')
            	),
            	array(
            		'caption' => 'Template 5',
            		'img' => sp()->assetUrl('images/model4.jpg')
            	),
            	array(
            		'caption' => 'Template 6',
            		'img' => sp()->assetUrl('images/model5.jpg')
            	),
            	array(
            		'caption' => 'Template 7',
            		'img' => sp()->assetUrl('images/model6.jpg')
            	),
            	array(
            		'caption' => 'Template 8',
            		'img' => sp()->assetUrl('images/model7.jpg')
            	),
            	array(
            		'caption' => 'Template 9',
            		'img' => sp()->assetUrl('images/model8.jpg')
            	),
            	array(
            		'caption' => 'Template 10',
            		'img' => sp()->assetUrl('images/model9.jpg')
            	),
            	array(
            		'caption' => 'Template 11',
            		'img' => sp()->assetUrl('images/model10.jpg')
            	)
            )
        ),

		'where_to_show' => array(
	       'type'				=> 'select',
	        'std'				=> 'both',
	        'options' 			=> array('wordpress' => 'Wordpress Pagination', 'woocommerce' => 'WooCommerce Pagination', 'both' => 'Both WooCommerce & Wordpress Pagination' ),
	        'title'				=> 'Where to Show',
	        'desc'				=> 'Default: Wordpress',
	        'size'				=> 'small'
	    ),

	    'next_label' => array(
	        'type' => 'text',
	        'std' => '&nbsp;',
	        'size' => 'small',
	        'title' => 'Next Label',
	        'force_width' => '260',
	        'desc' => 'Default: Next &raquo;'
	    ),

	    'previous_label' => array(
	        'type' => 'text',
	        'std' => '&nbsp;',
	        'size' => 'small',
	        'title' => 'Previous Label',
	        'force_width' => '260',
	        'desc' => 'Default: &laquo; Previous'
	    ),

	    'link_text_color' => array(
	        'type' => 'color_picker',
	        'std' => '#ffffff',
	        'size' => 'small',
	        'title' => 'Link Text Color',
	        'force_width' => '260',
	        'desc' => 'Pick your color'
	    ),

	    'current_item_text_color' => array(
	        'type' => 'color_picker',
	        'std' => '#ffffff',
	        'size' => 'small',
	        'title' => 'Current Item (not link) Text Color',
	        'force_width' => '260',
	        'desc' => 'Pick your color'
	    ),

	    'hover_link_text_color' => array(
	        'type' => 'color_picker',
	        'std' => '#f9ca24',
	        'size' => 'small',
	        'title' => 'Hover Link Text Color',
	        'force_width' => '260',
	        'desc' => 'Pick your color'
	    ),

	    'template_font_family' => array(
	        'type'				=> 'select',
	        'std'				=> 'Heebo',
	        'options' 			=> function_exists('sp') ? sp()->getAllGfonts() : array(),
	        'title'				=> 'Font Family',
	        'desc'				=> '<div class="sp-font-preview"></div>',
	        'size'				=> 'small'
	    ),

	    'template_font_size' => array(
	        'type' => 'text',
	        'std' => '16px',
	        'size' => 'small',
	        'title' => 'Font Size',
	        'force_width' => '260',
	        'desc' => 'Default: 14px'
	    ),


	    'sp_gap_number' => array(
	       'type'				=> 'select',
	        'std'				=> '1',
	        'options' 			=> function_exists('sp') ? sp()->sp_range_to_20() : array(),
	        'title'				=> 'Gap',
	        'desc'				=> 'From how many item display gap points? Default: 3',
	        'size'				=> 'small'
	    ),

	    'sp_range' => array(
	        'type'				=> 'select',
	        'std'				=> '1',
	        'options' 			=> function_exists('sp') ? sp()->sp_range_to_20() : array(),
	        'title'				=> 'Range',
	        'desc'				=> 'Default: 5',
	        'size'				=> 'small'
	    ),

	    'sp_anchor' => array(
	       'type'				=> 'select',
	        'std'				=> '1',
	        'options' 			=> function_exists('sp') ? sp()->sp_range_to_20() : array(),
	        'title'				=> 'Anchor',
	         'desc'				=> 'Default: 1',
	        'size'				=> 'small'
	    ),

	    'custom_css_selector' => array(
            'type' => 'text',
            'std' => '',
            'force_width' => '500',
            'size' => 'small',
            'title' => 'Custom CSS Blog Selector',
            'desc' => 'Please specify the custom selector if your theme has a custom pagination implemented. Ex: <code>.fusion-blog-archive .pagination</code>'
        ),
        'custom_css_woocommerce_selector' => array(
            'type' => 'text',
            'std' => '',
            'force_width' => '500',
            'size' => 'small',
            'title' => 'Custom CSS WooCommerce Selector',
            'desc' => 'Please specify the custom selector if your theme has a custom WooCommerce pagination implemented. Ex: <code>.fusion-blog-archive .pagination</code>'
        )
	    

	), // end elements
));
